"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _is = _interopRequireDefault(require("../util/is"));

var _logger = _interopRequireDefault(require("../util/logger"));

var _ = _interopRequireDefault(require(".."));

module.exports = function build(options) {
  if (_is["default"].nil(process.env.NODE_ENV)) {
    process.env.NODE_ENV = 'production';
  }

  return new _promise["default"](function (resolve, reject) {
    var configs = options.config.split(',');
    var wbpcs = configs.map(function (item) {
      var configPath = _path["default"].resolve(process.cwd(), item);

      if (!_fs["default"].existsSync(configPath)) {
        _logger["default"].warn("Config file ".concat(configPath, " does not exist.Use default config"));

        return new _["default"].Config().resolve();
      } // eslint-disable-next-line


      var config = require(configPath);

      if (!config._resolved) {
        return new _["default"].Config(config).resolve();
      }

      return config;
    }).reduce(function (result, item) {
      if (_is["default"].Array(item)) {
        return result.concat(item);
      }

      result.push(item);
      return result;
    }, []);

    var finished = function finished(err, stats) {
      if (err) {
        _logger["default"].error(err);

        return reject(err);
      }

      _logger["default"].info(stats.toString({
        colors: true,
        timings: true
      }));

      return resolve();
    };

    wbpcs.forEach(function (config) {
      config.mode = 'production';
      delete config._extends;
      delete config._resolved;
    });

    if (options.watch) {
      (0, _webpack["default"])(wbpcs).watch({}, finished);
    } else {
      (0, _webpack["default"])(wbpcs).run(finished);
    }
  });
};
//# sourceMappingURL=build.js.map