"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _logger = _interopRequireDefault(require("../util/logger"));

var _is = _interopRequireDefault(require("../util/is"));

var _loadDllPluginConfig = _interopRequireDefault(require("../util/load-dllPlugin-config"));

module.exports = function build(options) {
  return new _promise["default"](function (resolve, reject) {
    var configs = options.config.split(',');
    var wbpcs = configs.map(function (item) {
      var configPath = _path["default"].resolve(process.cwd(), item);

      if (!_fs["default"].existsSync(configPath)) {
        _logger["default"].fatal("Config file ".concat(configPath, " does not exist."));
      }

      return (0, _loadDllPluginConfig["default"])(require(configPath));
    }).reduce(function (result, item) {
      if (_is["default"].Array(item)) {
        return result.concat(item);
      }

      result.push(item);
      return result;
    }, []);

    var finished = function finished(err, stats) {
      if (err) {
        _logger["default"].error(err);

        return reject(err);
      }

      _logger["default"].info(stats.toString({
        colors: true,
        timings: true
      }));

      return resolve();
    };

    (0, _webpack["default"])(wbpcs).run(finished);
  });
};
//# sourceMappingURL=dll.js.map