"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _set = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/set"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _browserSync = _interopRequireDefault(require("browser-sync"));

var _webpackDevMiddleware = _interopRequireDefault(require("webpack-dev-middleware"));

var _webpackHotMiddleware = _interopRequireDefault(require("webpack-hot-middleware"));

var _writeFileWebpackPlugin = _interopRequireDefault(require("write-file-webpack-plugin"));

var _is = _interopRequireDefault(require("../util/is"));

var _logger = _interopRequireDefault(require("../util/logger"));

var _runNodeServer = _interopRequireDefault(require("../util/runNodeServer"));

var _webpackDevServer = _interopRequireDefault(require("../util/webpackDevServer"));

var _ = _interopRequireDefault(require(".."));

module.exports =
/*#__PURE__*/
function () {
  var _start = (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(options) {
    var configs, serverCount, wbpcs, sConfig, server;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            process.env.NODE_ENV = process.env.NODE_ENV || 'development';
            configs = options.config.split(',');
            serverCount = 0;
            wbpcs = configs.map(function (item) {
              var configPath = _path["default"].resolve(process.cwd(), item);

              if (!_fs["default"].existsSync(configPath)) {
                _logger["default"].warn("Config file ".concat(configPath, " does not exist. Use default config."));

                serverCount += 1;

                var _config = new _["default"].Config().resolve();

                delete _config._resolved;
                return _config;
              }

              var config = require(configPath);

              if (_is["default"].Array(config)) {
                config = config.map(function (item) {
                  if (!item._resolved) {
                    return new _["default"].Config(item).resolve();
                  }

                  return item;
                });
              } else if (!config._resolved) {
                config = new _["default"].Config(config).resolve();
              }

              if (_is["default"].Array(config)) {
                config.forEach(function (item) {
                  if (item.devServer) {
                    serverCount += 1;
                  }

                  delete item._resolved;
                });
              } else if (config.devServer) {
                serverCount += 1;
              }

              delete config._resolved;
              return config;
            }).reduce(function (result, item) {
              if (_is["default"].Array(item)) {
                return result.concat(item);
              }

              result.push(item);
              return result;
            }, []);

            if (serverCount > 1) {
              _logger["default"].fatal("Only one server support. Server count: ".concat(serverCount));
            }

            sConfig = wbpcs.find(function (item) {
              return !!item.devServer;
            });

            if (!(!sConfig || sConfig.target !== 'node')) {
              _context2.next = 12;
              break;
            }

            server = new _webpackDevServer["default"](wbpcs, options.port, options.host);
            _context2.next = 10;
            return server.run();

          case 10:
            _context2.next = 15;
            break;

          case 12:
            sConfig.plugins.push(new _writeFileWebpackPlugin["default"]({
              log: false
            }));
            _context2.next = 15;
            return new _promise["default"](function (resolve) {
              // 为client端增加热加载模块
              wbpcs.forEach(function (config) {
                config.mode = config.mode || 'development';

                if (config.target !== 'node') {
                  var whmClient = "webpack-hot-middleware/client?path=http://".concat(options.host, ":").concat(options.port, "/__webpack_hmr");

                  if (_is["default"].Array(config.entry)) {
                    config.entry.unshift(whmClient);
                  } else if (_is["default"].Object(config.entry)) {
                    (0, _keys["default"])(config.entry).forEach(function (key) {
                      if (_is["default"].Array(config.entry[key])) {
                        config.entry[key].unshift(whmClient);
                      } else {
                        config.entry[key] = [whmClient, config.entry[key]];
                      }
                    });
                  } else {
                    config.entry = [whmClient, config.entry];
                  }

                  config.plugins.push(new _webpack["default"].HotModuleReplacementPlugin());
                }

                delete config._extends;
                delete config._resolved;
              });
              var bundler = (0, _webpack["default"])(wbpcs);
              var wpMiddlewares = [];
              var hotMiddlewares = [];
              wbpcs.forEach(function (config, i) {
                if (config.target !== 'node') {
                  wpMiddlewares.push((0, _webpackDevMiddleware["default"])(bundler, {
                    publicPath: config.output.publicPath,
                    stats: config.stats
                  }));
                  hotMiddlewares.push((0, _webpackHotMiddleware["default"])(bundler.compilers[i]));
                }
              });

              var handleServerBundleComplete =
              /*#__PURE__*/
              function () {
                var _ref = (0, _asyncToGenerator2["default"])(
                /*#__PURE__*/
                _regenerator["default"].mark(function _callee() {
                  var server, bs;
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          handleServerBundleComplete = function handleServerBundleComplete(stats) {
                            return !stats.stats[1].compilation.errors.length && (0, _runNodeServer["default"])(sConfig);
                          };

                          _context.next = 3;
                          return (0, _runNodeServer["default"])(sConfig);

                        case 3:
                          server = _context.sent;
                          bs = _browserSync["default"].create();
                          bs.init({
                            ghostMode: false,
                            port: options.port,
                            proxy: {
                              target: server.host,
                              middleware: [].concat(wpMiddlewares, hotMiddlewares),
                              proxyOptions: {
                                xfwd: true
                              }
                            }
                          }, resolve);

                        case 6:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function handleServerBundleComplete() {
                  return _ref.apply(this, arguments);
                };
              }();

              bundler._pluginCompat.call({
                name: 'done',
                fn: function fn(stats) {
                  return handleServerBundleComplete(stats);
                },
                names: new _set["default"](['done'])
              });
            });

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  function start(_x) {
    return _start.apply(this, arguments);
  }

  return start;
}();
//# sourceMappingURL=start.js.map