"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _defineProperties = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-properties"));

var _getOwnPropertyDescriptors = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptors"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-symbols"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _lodash = require("lodash");

var _tdtoolMock = require("tdtool-mock");

var _loadConfig = _interopRequireDefault(require("./util/load-config"));

var _loadExtend = _interopRequireDefault(require("./util/load-extend"));

var _loadFileLoader = _interopRequireDefault(require("./util/load-file-loader"));

var _utils = require("./util/utils");

var _parse = _interopRequireDefault(require("./util/parse"));

var _preProcessedOptions = _interopRequireDefault(require("./util/preProcessedOptions"));

function ownKeys(object, enumerableOnly) { var keys = (0, _keys["default"])(object); if (_getOwnPropertySymbols["default"]) { var symbols = (0, _getOwnPropertySymbols["default"])(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return (0, _getOwnPropertyDescriptor["default"])(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty3["default"])(target, key, source[key]); }); } else if (_getOwnPropertyDescriptors["default"]) { (0, _defineProperties["default"])(target, (0, _getOwnPropertyDescriptors["default"])(source)); } else { ownKeys(source).forEach(function (key) { (0, _defineProperty2["default"])(target, key, (0, _getOwnPropertyDescriptor["default"])(source, key)); }); } } return target; }

exports.delay = _tdtoolMock.delay;
exports.mock = _tdtoolMock.mock;
exports.version = require('../package.json').version;
exports.webpackVersion = require('webpack/package.json').version;

var replacePath = function replacePath(sourcePath) {
  if (/^(rule)s?/gi.test(sourcePath)) {
    return sourcePath.replace(/^(rule)s?/gi, 'module.$1s');
  }

  if (/^(plugin)s?/g.test(sourcePath)) {
    return sourcePath.replace(/^(plugin)s?/g, '$1s');
  }

  return sourcePath;
};

var Config = function Config() {
  var _this = this;

  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  (0, _classCallCheck2["default"])(this, Config);

  this.add = function (sourcePath, value) {
    (0, _lodash.set)(_this.config, replacePath(sourcePath), value);
    return _this;
  };

  this.remove = function (sourcePath) {
    (0, _lodash.unset)(_this.config, replacePath(sourcePath));
    return _this;
  };

  this.concat = function (sourcePath, value) {
    var finalValue = (0, _lodash.concat)((0, _lodash.get)(_this.config, replacePath(sourcePath), []), value);
    (0, _lodash.set)(_this.config, replacePath(sourcePath), finalValue);
    return _this;
  };

  this.injectEntry = function (value) {
    _this.config.entry = (0, _utils.injectEntry)(_this.config.entry, value);
    return _this;
  };

  this.resolve = function () {
    return (0, _parse["default"])(_this.config);
  };

  this.options = (0, _preProcessedOptions["default"])(options);
  this.config = (0, _loadConfig["default"])(this.options);
  var handlers = {
    add: this.add,
    remove: this.remove,
    concat: this.concat
  };
  (0, _loadExtend["default"])(_objectSpread({}, handlers, {
    injectEntry: this.injectEntry
  }), _objectSpread({}, this.options));
  (0, _loadFileLoader["default"])(this, this.options);

  if (typeof this.options.webpack === 'function') {
    this.options.webpack(_objectSpread({}, handlers));
  }
};

exports.Config = Config;
//# sourceMappingURL=index.js.map