"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

function type(obj) {
  return Object.prototype.toString.call(obj);
}

function isInstalled(name) {
  try {
    require.resolve(name);

    return true;
  } catch (e) {
    return false;
  }
}

exports.String = function (obj) {
  return type(obj) === '[object String]';
};

exports.Array = function (obj) {
  return type(obj) === '[object Array]';
};

exports.Object = function (obj) {
  return type(obj) === '[object Object]';
};

exports.Boolean = function (obj) {
  return type(obj) === '[object Boolean]';
};

exports.Function = function (obj) {
  return type(obj) === '[object Function]';
};

exports.nil = function (obj) {
  return obj === null || obj === undefined;
};

exports.valid = function (obj) {
  return !!obj;
};

exports.pluginExists = function (name) {
  return isInstalled(name) || _fs["default"].existsSync(_path["default"].join(process.cwd(), 'node_modules', name));
};

exports.installed = isInstalled;
//# sourceMappingURL=is.js.map