"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty2 = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty2(exports, "__esModule", {
  value: true
});

exports["default"] = loadConfig;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _defineProperties = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-properties"));

var _getOwnPropertyDescriptors = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptors"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-symbols"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _progressBarWebpackPlugin = _interopRequireDefault(require("progress-bar-webpack-plugin"));

var _webpackManifestPlugin = _interopRequireDefault(require("webpack-manifest-plugin"));

var _copyWebpackPlugin = _interopRequireDefault(require("copy-webpack-plugin"));

var _terserWebpackPlugin = _interopRequireDefault(require("terser-webpack-plugin"));

var _is = _interopRequireDefault(require("./is"));

var _loadTemplate = _interopRequireDefault(require("./load-template"));

var _loadDevServer = _interopRequireDefault(require("./load-devServer"));

var _loadDllReferencePluginConfig = _interopRequireDefault(require("./load-dllReferencePlugin-config"));

function ownKeys(object, enumerableOnly) { var keys = (0, _keys["default"])(object); if (_getOwnPropertySymbols["default"]) { var symbols = (0, _getOwnPropertySymbols["default"])(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return (0, _getOwnPropertyDescriptor["default"])(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty3["default"])(target, key, source[key]); }); } else if (_getOwnPropertyDescriptors["default"]) { (0, _defineProperties["default"])(target, (0, _getOwnPropertyDescriptors["default"])(source)); } else { ownKeys(source).forEach(function (key) { (0, _defineProperty2["default"])(target, key, (0, _getOwnPropertyDescriptor["default"])(source, key)); }); } } return target; }

/**
 * generate tdtool config by user options
 *
 * @param options [user options]
 * @return config [tdtool config]
 */
function loadConfig(options) {
  var config = {
    entry: options.entry,
    target: options.target,
    mode: process.env.NODE_ENV,
    output: {
      path: _path["default"].resolve(process.cwd(), options.outputPath),
      publicPath: options.publicPath,
      filename: options.filename || (options.hash ? '[name].[contenthash:8].js' : '[name].js'),
      chunkFilename: options.hash ? '[name].[contenthash:8].async.js' : '[name].async.js',
      libraryTarget: options.target === 'node' ? 'commonjs2' : options.libraryTarget,
      library: options.moduleName,
      umdNamedDefine: options.libraryTarget === 'umd' || options.libraryTarget === 'amd'
    },
    plugins: {},
    module: {
      rules: {}
    },
    resolve: {
      extensions: ['.wasm', '.mjs', '.ts', '.tsx', '.js', '.json', '.jsx'],
      alias: {
        '@': _path["default"].resolve(process.cwd(), 'src')
      },
      modules: ['node_modules', _path["default"].resolve(process.cwd(), 'node_modules'), _path["default"].resolve(__dirname, '../../node_modules')].concat(options.modules).filter(_is["default"].valid)
    },
    optimization: _objectSpread({
      minimize: process.env.NODE_ENV === 'production',
      minimizer: [new _terserWebpackPlugin["default"]()]
    }, options.optimization)
  }; // define

  config.plugins.define = new _webpack["default"].DefinePlugin(_objectSpread({
    __DEV__: process.env.NODE_ENV === 'development',
    PUBLIC_PATH: options.publicPath
  }, options.define)); // template

  if (options.template || process.env.NODE_ENV === 'development' && options.template !== false) {
    (0, _assign["default"])(config.plugins, (0, _loadTemplate["default"])(options.template, options.mountElementId));
  } // alias


  if (options.alias) {
    config.resolve.alias = _objectSpread({}, config.resolve.alias, {}, options.alias);
  } // externals


  if (options.externals) {
    config.externals = options.externals;
  } // devtool


  if (process.env.NODE_ENV === 'development') {
    config.devtool = options.devtool || 'cheap-module-eval-source-map';

    if (options.target === 'node') {
      config.plugins.Banner = new _webpack["default"].BannerPlugin({
        banner: 'require("source-map-support").install();',
        raw: true,
        entryOnly: false
      });
    }
  } else {
    // 生产环境禁用devtool
    config.devtool = false;
  } // development


  if (process.env.NODE_ENV === 'development') {
    config.cache = true;
  } // development


  if (process.env.NODE_ENV === 'production') {
    config.bail = true;
  } // ProgressBarPlugin


  config.plugins.ProgressBar = new _progressBarWebpackPlugin["default"](); // DllReferencePlugin

  if (options.dll) {
    (0, _loadDllReferencePluginConfig["default"])(config, options);
  } // manifest


  if (process.env.NODE_ENV !== 'development' && options.manifest) {
    config.plugins.Manifest = new _webpackManifestPlugin["default"](options.manifest || {});
  } // copy plugin


  if (options.copy) {
    config.plugins.Copy = new _copyWebpackPlugin["default"]([].concat(options.copy));
  } // node


  if (options.target === 'node') {
    config.node = {
      console: false,
      global: false,
      process: false,
      Buffer: false,
      __filename: false,
      __dirname: false
    };
  } else {
    config.node = {
      fs: 'empty',
      net: 'empty',
      tls: 'empty'
    };
  } // dev server


  if ((options.devServer || process.env.NODE_ENV === 'development') && options.devServer !== 'ignore') {
    (0, _loadDevServer["default"])(config, _objectSpread({
      proxy: options.proxy || {}
    }, options.devServer || {}));
  } // stats


  config.stats = {
    // 打印信息控制
    colors: true,
    all: undefined,
    timings: true,
    publicPath: true,
    assets: true,
    entrypoints: true,
    modules: false,
    chunks: true,
    chunkGroups: true,
    chunkModules: false,
    children: false,
    hash: false,
    cached: false,
    cachedAssets: false,
    reasons: process.env.NODE_ENV === 'development'
  };
  return config;
}
//# sourceMappingURL=load-config.js.map