"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _webpack = _interopRequireDefault(require("webpack"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _logger = _interopRequireDefault(require("./logger"));

var _is = _interopRequireDefault(require("./is"));

function addPlugin(config, key, context, manifest, name) {
  if (!_fs["default"].existsSync(manifest)) {
    _logger["default"].fatal("Dll fill does not exist. Did you forget to run the command 'tdtool dll'?");
  } else {
    config.plugins[key] = new _webpack["default"].DllReferencePlugin({
      // context,
      manifest: require(manifest),
      name: name
    });
  }
}

function logTypeError() {
  _logger["default"].fatal("DllPlugin only supply an Array or Object(the value must be an Array) as entry");
}

module.exports = function (config, options) {
  var dllEntry = options.dll.entry;
  var dllContextPath = options.dll.path;

  if (_is["default"].Array(dllEntry)) {
    var manifest = _path["default"].join(dllContextPath, "vendor.js.json");

    addPlugin(config, 'DllReferencePlugin', dllContextPath, manifest, 'vendor_library');
  } else if (_is["default"].Object(dllEntry)) {
    (0, _keys["default"])(dllEntry).forEach(function (key) {
      if (!_is["default"].Array(dllEntry[key])) {
        logTypeError();
      } else {
        var _manifest = _path["default"].join(dllContextPath, "".concat(key, ".js.json"));

        addPlugin(config, "DllReferencePlugin".concat(key), dllContextPath, _manifest, "".concat(key, "_library"));
      }
    });
  } else {
    logTypeError();
  }
};
//# sourceMappingURL=load-dllReferencePlugin-config.js.map