"use strict";

var URL_LOADER_LIMIT = 10000;

module.exports = function (config, options) {
  config.add('rule.tdicon', {
    test: /tdicon\.(woff|woff2|ttf|eot|svg)($|\?)/,
    use: [{
      loader: 'url-loader',
      options: {
        limit: options && options.urlLoaderLimit ? options.urlLoaderLimit : URL_LOADER_LIMIT,
        name: 'fonts/[name].[ext]'
      }
    }]
  });
  config.add('rule.font', {
    test: /\.(woff|woff2|ttf|eot)/,
    use: [{
      loader: 'url-loader',
      options: {
        limit: options && options.urlLoaderLimit ? options.urlLoaderLimit : URL_LOADER_LIMIT
      }
    }]
  });
  config.add('rule.txt', {
    test: /\.txt$/,
    loader: 'raw-loader'
  });
  config.add('rule.IMAGE', {
    test: /\.(png|jpg|jpeg|gif)(\?v=\d+\.\d+\.\d+)?$/i,
    loader: 'url-loader',
    query: {
      limit: options && options.urlLoaderLimit ? options.urlLoaderLimit : URL_LOADER_LIMIT
    }
  });
  config.add('rule.svg', {
    test: /\.svg(\?v=\d+\.\d+\.\d+)?$/,
    loader: 'url-loader',
    query: {
      limit: 10000,
      minetype: 'image/svg+xml'
    }
  });
};
//# sourceMappingURL=load-file-loader.js.map