"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty2 = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty2(exports, "__esModule", {
  value: true
});

exports["default"] = loadTemplate;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _defineProperties = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-properties"));

var _getOwnPropertyDescriptors = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptors"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-symbols"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _path = _interopRequireDefault(require("path"));

var _htmlWebpackPlugin = _interopRequireDefault(require("html-webpack-plugin"));

var _is = _interopRequireDefault(require("./is"));

var _logger = _interopRequireDefault(require("./logger"));

function ownKeys(object, enumerableOnly) { var keys = (0, _keys["default"])(object); if (_getOwnPropertySymbols["default"]) { var symbols = (0, _getOwnPropertySymbols["default"])(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return (0, _getOwnPropertyDescriptor["default"])(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty3["default"])(target, key, source[key]); }); } else if (_getOwnPropertyDescriptors["default"]) { (0, _defineProperties["default"])(target, (0, _getOwnPropertyDescriptors["default"])(source)); } else { ownKeys(source).forEach(function (key) { (0, _defineProperty2["default"])(target, key, (0, _getOwnPropertyDescriptor["default"])(source, key)); }); } } return target; }

function loadTemplate() {
  var template = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  var mountElementId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'root';
  var templateParameters = {
    mountElementId: mountElementId,
    title: 'title'
  };
  var templates = {};

  if (template === true) {
    templates['index.html'] = new _htmlWebpackPlugin["default"]({
      template: _path["default"].resolve(__dirname, '../index.html'),
      templateParameters: templateParameters
    });
  } else if (_is["default"].String(template)) {
    templates['index.html'] = new _htmlWebpackPlugin["default"]({
      filename: 'index.html',
      template: _path["default"].resolve(process.cwd(), template),
      templateParameters: templateParameters
    });
  } else if (_is["default"].Object(template)) {
    for (var name in template) {
      if (Object.prototype.hasOwnProperty.call(template, name)) {
        if (_is["default"].String(template[name])) {
          templates[name] = new _htmlWebpackPlugin["default"]({
            filename: name,
            template: _path["default"].resolve(process.cwd(), template[name]),
            templateParameters: templateParameters
          });
        } else {
          template[name].filename = template[name].filename || name;
          template[name].templateParameters = _objectSpread({}, templateParameters);
          templates[name] = new _htmlWebpackPlugin["default"](template[name]);
        }
      }
    }
  } else if (_is["default"].Array(template)) {
    template.forEach(function (item) {
      if (!item.filename) {
        _logger["default"].fatal('template filename is required.');
      }

      templates[item.filename] = new _htmlWebpackPlugin["default"](item);
    });
  }

  return templates;
}
//# sourceMappingURL=load-template.js.map