"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _logger = _interopRequireDefault(require("./logger"));

module.exports = function run(fn, options) {
  var task = typeof fn["default"] === 'undefined' ? fn : fn["default"];
  var start = new Date();

  _logger["default"].warn("Starting '".concat(task.name, "'..."));

  return task(options).then(function () {
    var end = new Date();
    var time = end.getTime() - start.getTime();

    _logger["default"].success("Finished '".concat(task.name, "' after ").concat(time, " ms"));
  })["catch"](function (err) {
    return _logger["default"].fatal(err.stack);
  });
};
//# sourceMappingURL=run-command.js.map