"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/slicedToArray"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _path = _interopRequireDefault(require("path"));

var _child_process = _interopRequireDefault(require("child_process"));

var RUNNING_REGEXP = /The server is running at http:\/\/(.*?)\//;
var server;
var pending = true;
var serverPath;

function runServer(serverConfig) {
  serverPath = _path["default"].join(serverConfig.output.path, serverConfig.output.filename);
  return new _promise["default"](function (resolve) {
    function onStdOut(data) {
      var time = new Date().toTimeString();
      var match = data.toString('utf8').match(RUNNING_REGEXP);
      process.stdout.write(time.replace(/.*(\d{2}:\d{2}:\d{2}).*/, '[$1] '));
      process.stdout.write(data);

      if (match) {
        var _match = (0, _slicedToArray2["default"])(match, 2);

        server.host = _match[1];
        server.stdout.removeListener('data', onStdOut);
        server.stdout.on('data', function (x) {
          return process.stdout.write(x);
        });
        pending = false;
        resolve(server);
      }
    }

    if (server) {
      server.kill('SIGTERM');
    }

    server = _child_process["default"].spawn('node', [serverPath], {
      env: (0, _assign["default"])({
        NODE_ENV: 'development'
      }, process.env),
      silent: false
    });

    if (pending) {
      server.once('exit', function (code, signal) {
        if (pending) {
          throw new Error("Server terminated unexpectedly with code: ".concat(code, " signal: ").concat(signal));
        }
      });
    }

    server.stdout.on('data', onStdOut);
    server.stderr.on('data', function (x) {
      return process.stderr.write(x);
    });
    return server;
  });
}

process.on('exit', function () {
  if (server) {
    server.kill('SIGTERM');
  }
});
var _default = runServer;
exports["default"] = _default;
//# sourceMappingURL=runNodeServer.js.map